// TestVBoxFS.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <string>
#include <stdio.h>

int _tmain(int argc, _TCHAR* argv[])
{
	while(true){
		for (int i=0; i<1000; i++){
			fprintf(stderr, "."); fflush(stderr);
			printf("Testing CreateFile( %s, FILE_FLAG_DELETE_ON_CLOSE)\n", argv[1]);
			::SetLastError(0);
			HANDLE hTest = CreateFile(	argv[1], GENERIC_WRITE, FILE_SHARE_DELETE|FILE_SHARE_READ|FILE_SHARE_WRITE, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_DELETE_ON_CLOSE, NULL);
			if (hTest == INVALID_HANDLE_VALUE){
				printf("FAILED to open file %s: %08X\n", argv[1], ::GetLastError());
				printf("===================================================================================================================================================\n");
				fprintf(stderr, "\n==== E ====\n"); fflush(stderr);
			} else {
				printf("Success %08X\n", ::GetLastError());
				::CloseHandle(hTest);
			}

			hTest = INVALID_HANDLE_VALUE;
			printf("Testing CreateFile( %s, FILE_ATTRIBUTE_NORMAL)\n", argv[1]);
			hTest = CreateFile(	argv[1], GENERIC_WRITE, FILE_SHARE_DELETE|FILE_SHARE_READ|FILE_SHARE_WRITE, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
			if (hTest == INVALID_HANDLE_VALUE){
				printf("FAILED to open file %s: %08X\n", argv[1], ::GetLastError());
				printf("===================================================================================================================================================\n");
				fprintf(stderr, "\n==== E ====\n"); fflush(stderr);
			} else {
				printf("Success %08X\n", ::GetLastError());
				::CloseHandle(hTest);
			}

			BOOL ret = ::DeleteFile( argv[1] );
			printf("DeleteFile(%s) = %d\n", argv[1], (int)ret);
			printf("\n");
		}
		fprintf(stderr, "\n");
		
		printf("------------------------------------------------------------------------------------------------\n");
		printf("------------------------------------------------------------------------------------------------\n");
		printf("------------------------------------------------------------------------------------------------\n");
		printf("==== SLEEPING for 5000ms ====\n");
		fprintf(stderr, "\nSLEEPING for 5000ms\n");
		Sleep(5000);
		printf("------------------------------------------------------------------------------------------------\n");
		printf("------------------------------------------------------------------------------------------------\n");
		printf("------------------------------------------------------------------------------------------------\n");

	}

	return 0;
}

